domains
	osztaly=symbol
	nev=symbol
	tantargy=symbol
	lista=nev*

database
	volt(osztaly,nev)

predicates
	verseny(osztaly,nev,tantargy)

	Afeladat
	Aseged(osztaly)
	nemindult(osztaly)
	
	Bfeladat
	Bseged(osztaly,nev,osztaly,nev)
	vankulonbozo(osztaly,nev,osztaly,nev)
	
	Cfeladat
	Cseged(osztaly,tantargy)
	indult(osztaly,tantargy)
	
	Dfeladat
	Dseged(osztaly)
	kivalogat(osztaly,lista,lista) 
	beszur(nev,lista,lista)
	szabad(osztaly,nev)
	kiir(lista)
	
clauses
	verseny("1a",feri,angol).
	verseny("1a",ferko,nemet).
	verseny("1c",nandi,angol).
	verseny("3c",bela,nemet).
	verseny("3c",feri,matek).

	
	Afeladat if Aseged(Oszt) and write("A megfelelo osztaly:",Oszt,"\n").
	Afeladat if write("Nincs megfelelo osztaly!\n").
	Aseged(Oszt) if verseny(Oszt,_,_) and not(nemindult(Oszt)).
	nemindult(Oszt) if verseny(_,_,Targy) and not (verseny(Oszt,_,Targy)).

	Bfeladat if 
		write("1. diak neve:") and readln(N1) and 
		write("1. diak osztalya:") and readln(O1) and 
		write("2. diak neve:") and readln(N2) and 
		write("2. diak osztalya:") and readln(O2) and 		
		Bseged(O1,N1,O2,N2) and
		write("Pontosan ugyanazokon a versenyeken indultak!\n").
	Bfeladat if 
		write("Nem pontosan ugyanazokon a versenyeken indultak!\n").
	Bseged(O1,N1,O2,N2) if 
		verseny(O1,N1,_) and verseny(O2,N2,_) and 
		not(vankulonbozo(O1,N1,O2,N2)).
	vankulonbozo(O1,N1,O2,N2) if 
		verseny(O1,N1,T) and not(verseny(O2,N2,T)) and ! or 
		verseny(O2,N2,T) and not(verseny(O1,N1,T)).
		
	Cfeladat if 
		write("A tantargy:") and readln(Targy) and 
		Cseged(Oszt,Targy) and write("A megfelelo osztaly:",Oszt).
	Cfeladat if write("Nincs megfelel osztly!\n").
	Cseged(Oszt,Targy) if verseny(Oszt,_,_) and not(indult(Oszt,Targy)). 
	indult(Oszt,Targy) if verseny(Oszt,_,Targy).

	Dfeladat if 
		write("Az osztaly:") and readln(Oszt) and 
		Dseged(Oszt).
	Dseged(Oszt) if 
	        retractall(volt(_,_)) and
		kivalogat(Oszt,[],Mibe) and 
		write("\nA versenyzo tanulok:\n") and kiir(Mibe).

	kivalogat(Oszt,[],Mibe) if 
		verseny(Oszt,Nev,_ ) and assert(volt(Oszt,Nev)) and 
		kivalogat(Oszt,[Nev],Mibe).
	kivalogat(Oszt,Lista,Mibe) if 
		verseny(Oszt,Nev,_) and szabad(Oszt,Nev) and 
		beszur(Nev,Lista,ErLista) and ! and 
		kivalogat(Oszt,ErLista,Mibe) or Mibe=Lista.
	
	beszur(Mit,[],[Mit]).
	beszur(Mit,Mibe,[Mit|Mibe]). 
	
	szabad(Oszt,Nev) if 
	   volt(Oszt,Nev) and ! and fail or asserta(volt(Oszt,Nev)).
	
	kiir([]).
	kiir([E|Lista]) if write(E, " ") and kiir(Lista).
	
	
goal
       clearwindow and
	   write("\nA FELADAT:\n") and Afeladat and 
	   write("\nB FELADAT:\n") and Bfeladat and 
	   write("\nC FELADAT:\n") and Cfeladat and 
	   write("\nD FELADAT:\n") and Dfeladat.			