/* a/ adj meg egy olyan nyelvet, amit csak egy ember beszel
   b/ adj meg egy olyan nyelvet, amit mindenki beszel
   c/ add meg, hogy hnyfle nyelv van
   d/ add meg, hogy melyik nyelvet hnyan beszelik
   e/ adj meg ket embert, akik nem ertik meg egymast
*/

domains 
  nev=string
  nyelv=string
  

    
predicates
     /* tny */
  beszel(nev,nyelv)

     /* afel-hoz */
 afel
  csakegybeszel(symbol)	
  masis(symbol, symbol)

     /* bfel-hoz */
 bfel 
  NemMindenki(nyelv)
 

   /* c felhoz*/
  cfel
  hannyelv(integer)
  szamol(integer)

  /* d felhoz*/
  dfel
  nyelvszamol(nyelv,integer)
  melyiknyelvethanyan

     /* efel-hoz*/
  efel
  MegertikEgymast(nev,nev)
   
 
 

database

   volt(nyelv)
   embervolt(nev)
  
clauses
	beszel(erika,francia).
	beszel(andi,angol).
	beszel(andi,nemet).
	beszel(bela,angol).
	beszel(cili,angol).
	beszel(cili,francia).
	beszel(dani,angol).
	beszel(erika,angol).
	beszel(feri,spanyol).	
	beszel(geza,olasz).
	beszel(janos,kinai).
	beszel(feri,angol).
	beszel(geza,angol).
	beszel(janos,angol).
afel if csakegybeszel(X) and write(X) and write(" nyelvet csak egy ember beszli.")
	or write("Nincs olyan nyelv, amit csak egy ember beszl.").
csakegybeszel(X)if beszel(Z,X) and not (masis(Z,X)).
	masis(Z,X) if beszel(Q,X) and Z<>Q.

NemMindenki(Nyelv) if beszel(X,_) and not(beszel(X,Nyelv)).

bfel if beszel(_,Nyelv) and not(NemMindenki(Nyelv)) and write("Mindenki tudja ",Nyelv)                   
              or write("Nincs kzs nyelv").
cfel if hannyelv(Db) and write(Db," fele nyelvet beszelnek").
hannyelv(Db) if retractall(volt(_)) and szamol(Db).
szamol(Db) if beszel(_,N) and not (volt(N)) 
           and assert(volt(N)) and szamol(Tobbi) and Db=Tobbi+1 and !
           or Db=0. 

dfel if retractall(volt(_)) and melyiknyelvethanyan and nl.
nyelvszamol(X,Db) if beszel(E,X) and not (embervolt(E)) 
	           and assert(embervolt(E)) and nyelvszamol(X,Tobbi) and Db=Tobbi+1 and !
	           or Db=0.
melyiknyelvethanyan if beszel(_,X) and not (volt(X))
       and assert(volt(X)) and retractall(embervolt(_))
         and nyelvszamol(X,Db) and write("Az ",X, " nyelvet ",DB," ember beszeli.") and nl 
         and melyiknyelvethanyan or nl./*Csak azert, hogy ne hamis ertekkel 
             terjen vissza a goal-ba*/ 

  MegertikEgymast(Nev1,Nev2) if beszel(Nev1,Nyelv) and beszel(Nev2,Nyelv).
 efel if beszel(Nev1,_) and beszel(Nev2,_) and Nev1 <> Nev2 and
        not(MegertikEgymast(Nev1,Nev2)) and write(Nev1," s ", Nev2,
        " nem erti meg egymast ")
        or write("nincs olyan pr, akik nem rtik meg egymast").
  
 
goal 
 clearwindow and 
 afel and nl and 
 bfel and nl and 
 cfel and nl and 
 dfel and nl and 
 efel and nl .