/*trace*/
domains
  nev=symbol
  ajandek=symbol
  nevlista=nev*
  
 database
  szamolt(nev,nev)
  felirt(nev)
  kezelt_ajandek(ajandek)
  darab(ajandek,integer)
  
 predicates
  vesz(nev,nev,ajandek)
  nemkolcs(nev,nev)
  afeladat 

  vanakinemkap(nev)
  bfeladat

  ajandekdb(ajandek,integer)
  beir_ajandekdb(ajandek) 
  beir_ajandekokdb
  max(ajandek,integer) 
  van_tobb(integer)
  cfeladat
  kiir
  
  ajandekozott(nev,nevlista)
  kiirlista(nevlista)
  dfeladat
 
 clauses
  vesz(maria,andi,baba).
  vesz(andi,maria,babahaz).
  vesz(janos,andi,baba).
  vesz(maria,vera,kocsi).
  vesz(janos,david,baba).
  vesz(andi,peter,babahaz).
  vesz(janos,kalman,kocsi).
  vesz(maria,peter,baba).
  /************************* A feladat ************************************/
  nemkolcs(A,B) if
   vesz(A,B,_) and not(vesz(B,A,_)).
 
  afeladat if
   nemkolcs(A,B) and
   write("Van 2 olyan... :\n",A," ",B,"\n") or
   write("Mindenki kolcsonosen...\n").
   
  /************************* B feladat ************************************/     
  vanakinemkap(A) if
   vesz(A,_,_) and not(vesz(_,A,_)).
  
  bfeladat if
   vanakinemkap(A) and write(A," vesz, de nem kap.\n")  or
   write("Mindenki jl jr...\n").
   
  /************************* C feladat ************************************/      
  ajandekdb(Aj,Db) if 
   vesz(A,B,Aj) and not(szamolt(A,B)) and assert(szamolt(A,B)) and
   ajandekdb(Aj,Dbmar) and Db=Dbmar+1 or Db=0.
  
  beir_ajandekdb(Aj) if
   retractall(szamolt(_,_)) and
   ajandekdb(Aj,Db) and ! and
   assert(darab(Aj,Db)).
   
  beir_ajandekokdb if
   vesz(_,_,Aj) and 
   not(kezelt_ajandek(Aj)) and assert(kezelt_ajandek(Aj)) and
   beir_ajandekdb(Aj) and
   fail or true.
   
  max(Aj,Mennyi) if darab(Aj,Mennyi) and not(van_tobb(Mennyi)).
  van_tobb(Mennyi) if darab(_,Db) and Db>Mennyi.
   
  cfeladat if
   retractall(darab(_,_)) and retractall(kezelt_ajandek(_)) and 
   beir_ajandekokdb and 
   max(MaxAj,MaxDb) and 
   write("A legtobb ajandek:\n ",MaxAj,'-',MaxDb) 
   and write(":\nDarabok:\n") and kiir.
  
  kiir if
   darab(Aj,Db) and write(Aj,'-',Db,"\n") and fail or true.
    
 /************************* D feladat ************************************/            
  ajandekozott(A,[Ember|Tobbiek]) if
    vesz(A,Ember,_) and not(felirt(Ember)) and assert(felirt(Ember))
    and ajandekozott(A,Tobbiek).
   ajandekozott(_,[]) if true.
   
  kiirlista([]) if true.
  kiirlista([E|Maradek]) if write(E,"\n") and kiirlista(Maradek).
      
  dfeladat if
      write("Kinek az ajndkozottjai:\n") and readln(Ki) and
      retractall(felirt(_)) and
      ajandekozott(Ki,Lista) and kiirlista(Lista).  
      
 goal
   clearwindow and write("A feladat:\n") and afeladat and readln(_) and
   clearwindow and write("B feladat:\n") and bfeladat and readln(_) and
   clearwindow and write("C feladat:\n") and cfeladat and readln(_) and
   clearwindow and write("D feladat:\n") and dfeladat.  
