Domains
  tblokk=string
  ttantargy=string
  thallgato=string
  ttantargylista=ttantargy*

Database
  marvolt(ttantargy)

Predicates
  blokk(tblokk,ttantargy).
  hallgato(thallgato,ttantargy).
  
/* A feladat: */
  hanytargy(tblokk,integer)
  afeladat

/* B feladat: */
  csakegyblokkban(ttantargy)
  nemcsakegyblokkban(ttantargy)
  bfeladat

/* C feladat: */
  teljesitette(thallgato,tblokk)
  nemteljesitette(thallgato,tblokk)
  cfeladat
  
/*D feladat: */  
  tobbenbennevannak(ttantargylista)
  kiir(ttantargylista)
  dfeladat
  
Clauses
  blokk("D blokk",t1).
  blokk("D blokk",t2).
  blokk("D blokk",t3).
  blokk("D blokk",t4).
  blokk("A blokk",t5).
  blokk("A blokk",t1).
  blokk("C blokk",t7).
  blokk("C blokk",t8).
  blokk("C blokk",t9).
  hallgato(nev1,t1).
  hallgato(nev2,t3).
  hallgato(nev2,t4).


  hanytargy(B, Db) if 
    blokk(B, T) and 
	not(marvolt(T)) and assert(marvolt(T)) and ! and 
	hanytargy(B, DbMar) and Db=DbMar+1 or 
	Db=0.

  afeladat if 
	write("Blokk neve: ") and  readln(Blokk) and 
	retractall(marvolt(_)) and 
	hanytargy(Blokk, Db) and 
	write("A(z) ", Blokk, " nevu blokk targyainak szama: ", Db) and nl. 

  csakegyblokkban(T) if blokk(_,T) and not(nemcsakegyblokkban(T)).
  nemcsakegyblokkban(T) if blokk(B1,T) and blokk(B2,T) and B1<>B2. 

  bfeladat if 
	csakegyblokkban(T) and write("A(z) ", T, " csak egy blokkhoz tartozik.") and nl or 
	write("Nincs olyan targy, ami csak egy blokkhoz tartozik.") and nl. 


  teljesitette(H, B) if 
	hallgato(H,_) and not(nemteljesitette(H,B)).
  nemteljesitette(H,B) if
	blokk(B,T) and not(hallgato(H,T)).

  cfeladat if 
	write("Tanulo neve: ") and readln(Hallgato) and nl and 
	write("Blokk neve: ") and readln(Blokk) and 
	teljesitette(Hallgato, Blokk) and 
	write("A tanulo teljesitette a blokkot.") and nl or 
	write("A tanulo NEM teljesitette a blokkot.") and nl.
  
  tobbenbennevannak(L) if
     nemcsakegyblokkban(T) and 
     not(marvolt(T)) and assert(marvolt(T)) and ! and 
     tobbenbennevannak(LMar) and L=[T|LMar] or
     L=[].	
  
  kiir([]).
  kiir([E|Lista]) if 
	write(E, " ") and kiir(Lista).
  
  dfeladat if
	retractall(marvolt(_)) and tobbenbennevannak(L) and kiir(L).
	
Goal
  clearwindow and
  write("A feladat: ") and nl and afeladat and nl and
  write("B feladat: ") and nl and bfeladat and nl and
  write("C feladat: ") and nl and cfeladat and nl and
  write("D feladat: ") and nl and dfeladat and nl.