/*trace*/
domains
  azonosito=symbol
  nev=symbol
  targy=symbol
  osztaly=symbol
  lista=azonosito*
  
database
  marvolt(azonosito)
    
predicates
  tanar(azonosito,nev)
  tanit(azonosito,targy,osztaly)
  
  Afeladat
  mindben(nev)
  nemmindben(azonosito)
  
  Bfeladat
  egyszakos(nev)
  tobbszakos(azonosito)
  
  Cfeladat
  kivalogat(lista)
  nemmegfelelo(azonosito)
  kiir(lista)
  
  Dfeladat
  min(osztaly,integer)
  tanardb_torlessel(osztaly,integer)
  tanardb(osztaly,integer)
  vankisebb(integer)
    
clauses
  tanar(t0,"Nagy Antal").
  tanar(t1,"Nemes Anita").
  tanar(t2,"Kiss Lajos").
  
  tanit(t0,matek,"1A").
  tanit(t0,fizika,"1A").
  tanit(t0,tesi,"3A").
  tanit(t1,matek,"2A").
  tanit(t1,magyar,"1A").
  tanit(t1,angol,"3A").
  tanit(t2,magyar,"1A").
  tanit(t2,magyar,"2A").
  
  Afeladat if
	write("A feladat:") and nl and
	mindben(Nev) and write(Nev) or
	write("Nincs ilyen tanar.").
  mindben(Nev) if   
    	tanar(Azon,Nev) and not(nemmindben(Azon)).
  nemmindben(Azon) if 
	tanit(_,_,Oszt) and not(tanit(Azon,_,Oszt)).
  
  Bfeladat if 
	write("B feladat:") and nl and
	egyszakos(Nev) and write(Nev) or
	write("Nincs ilyen tanar.").
  egyszakos(Nev) if
	tanar(Azon,Nev) and not(tobbszakos(Azon)).
  tobbszakos(Azon) if 
	tanit(Azon,Targy1,_) and tanit(Azon,Targy2,_) and Targy1<>Targy2. 
	
  Cfeladat if 
	write("C feladat:") and nl and
	retractall(marvolt(_)) and
	kivalogat(Lista) and 
	kiir(Lista).

  kivalogat(Lista) if 
	tanar(Azon,_) and not(nemmegfelelo(Azon)) and 
	not(marvolt(Azon)) and assert(marvolt(Azon)) and 
	kivalogat(MarLista) and Lista=[Azon|MarLista] or
	Lista=[].
	
  nemmegfelelo(Azon) if
    	tanit(Azon,Targy,Oszt1) and tanit(Azon,Targy,Oszt2) and
	Oszt1<>Oszt2.
	
  kiir([]).
  kiir([Azon|Lista]) if write(Azon, " ") and kiir(Lista).
  
  Dfeladat if
    	min(MinOsztaly,MinDb) and
    	write("D feladat") and nl and
    	write(Minosztaly," (",MinDb," tanar)").
  
  min(Osztaly,Mennyi) if 
    	tanit(_,_,Osztaly) and 
    	tanardb_torlessel(Osztaly, Mennyi) and
    	not(vankisebb(Mennyi)).

  tanardb_torlessel(Osztaly,Db) if
        retractall(marvolt(_)) and tanardb(Osztaly,Db).
        
  tanardb(Osztaly,Db) if
    	tanit(Azon,_,Osztaly) and 
    	not(marvolt(Azon)) and assert(marvolt(Azon)) and ! and 
    	tanardb(Osztaly,DbMar) and Db=DbMar+1 or 
    	Db=0.
      
  vankisebb(Mennyi) if 
	tanit(_,_,Osztaly) and 
	tanardb_torlessel(Osztaly,Db) and
	Mennyi>Db.
  
goal
  clearwindow and
  nl and Afeladat and
  nl and Bfeladat and
  nl and Cfeladat and
  nl and Dfeladat.