
/*
Portia ladikai feladat listas megoldasa
 A ladak feliratai
 arany:ebben van
 ezust:nem itt van
 olom:nem az aranyban van
 
 peremfeltetel: legfeljebb 1 igaz az allitasok kozul

*/

domains
 
   elem=string
   lista=elem*

predicates

   elemek(elem)

   bennevan(elem,lista)
   kihagy(elem,lista,lista)
   csakegyszer(elem,lista)

   
   allitas1(lista)  
       
   allitas2(lista)

   allitas3(lista)

   legf1igaz(lista)

   megoldas(lista)
   
   kiiras(lista,lista)
   
   valasz(lista)
   
   melyik(lista)
   
clauses

   elemek(itt).                 /* az itt elem van a listban azon a helyen, 
                                   amelyik ladaban a kp van */
   elemek(nem).
   
   
   
   allitas1([ itt,nem, nem]).   /* a ladak felirata */
   allitas2([ itt,nem,nem]).
   allitas2([nem,nem,itt]).
   allitas3([nem,itt,nem]).
   allitas3([nem,nem, itt]).
    
   legf1igaz(L) if not(allitas1(L)) and not(allitas2(L)) and not(allitas3(L)). 
   legf1igaz(L) if allitas1(L) and not(allitas2(L)) and not(allitas3(L)). 
   legf1igaz(L) if not(allitas1(L)) and allitas2(L) and not(allitas3(L)). 
   legf1igaz(L) if not(allitas1(L)) and not(allitas2(L)) and allitas3(L). 
   
           /*egy adott elem benne van-e egy listaban*/
           
   bennevan(_,[]) if fail and !. 
   bennevan(Elem,[Elem|_]).
   bennevan(Elem,[_|Lista]) if bennevan(Elem,Lista).                             
   
           /* egy elemet kihagy a listabol, ha benne van  */
 
   kihagy(_,[],[]) if !.    
   kihagy(Elem,[Elem|Lista],Lista) if !.
   kihagy(Elem,[Elem2|Lista],[Elem2|Lista2]) if kihagy(Elem,Lista,Lista2).
   
          /* egy elem, ne legyen benne ktszer a listaban, de egyszer igen!!*/
          
   csakegyszer(Elem,Lista) if bennevan(Elem,Lista) and kihagy(Elem,Lista,Lista2) 
                                and not(bennevan(Elem,Lista2)). 
                                
          /* megkapjuk az itt, nem, nem listat.  */
          
   megoldas([E1,E2,E3]) if elemek(E1) and elemek(E2) and elemek(E3) and 
                           csakegyszer(itt,[E1,E2,E3]) and 
                           legf1igaz([E1,E2,E3]) and !. 
   megoldas([]).
          /* ne a listabol kelljen kitalalni a valaszt*/
          
   kiiras([],_) if write("nincs megoldas") and !.
   kiiras([E1|_],[Lada|_]) if E1=itt and write(Lada," ladaban van a kep") and nl and !.
   kiiras([_|Lista],[_|Tobbi])  if kiiras(Lista,Tobbi).  
   
         /* konstans lista felvetele*/   
   melyik([arany,ezust,olom]).
   
   
         /* vegso eredmeny...*/
         
   valasz(Lista) if megoldas(Lista) and melyik(Melyik) and kiiras(Lista,Melyik).
   
  
   goal
      clearwindow and write("a feladat:  Portia ladikaja 1.") and nl and 
      valasz(Lista).
      
