database
  voltunk(symbol) /*azok a varosok, ahol mar jartunk a megoldas soran*/
  vonal(symbol,symbol) /*a megoldas soran erintett utak*/

predicates
  
  ut(symbol,symbol)
   
  vanut(symbol,symbol) /*ket varos kozott van-e repulout?*/
  eljuthatunk(symbol,symbol) /*egyik varosbol eljuthatunk-e a masikba?*/
  szabad(symbol) /*ha az adott varosban jartunk mar akkor hamis, kulonben igaz*/
  program(symbol,symbol) 
  kovet(symbol,symbol)

clauses

  /*a graf leirasa*/ 
  ut(bp,varso). 
  ut(bp,london). 
  ut(london,tokio).
  vanut(X,Y) if ut(X,Y) or ut(Y,X).

  /*a feladat megoldasa adatbazis segitsegevel*/
  eljuthatunk(X,Y) if 
        /*van ut a ket varos kozott:*/ 
        vanut(X,Y) and asserta(vonal(X,Y)) or
        /*nincs ut a ket varos kozott:*/
        vanut(X,Z) and szabad(Z) and asserta(vonal(X,Z)) and eljuthatunk(Z,Y).

  szabad(Z) if  
        /*mar voltunk az adott varosban:*/
        voltunk(Z) and ! and fail or 
        /*meg nem jartunk az adott varosban:*/
        asserta(voltunk(Z)).

  program(A,B) if 
 	clearwindow and
 	retractall(voltunk(_)) and retractall(vonal(_,_)) and
 	asserta(voltunk(A)) and eljuthatunk(A,B) and 
 	kovet(A,B).

  /*az utvonal kiirasa*/
  kovet(A,B) if
	vonal(A,B) and write(B,"<-") and write(A) or 
	vonal(Z,B) and Z<>A and write(B,"<-") and kovet(A,Z).              
	
 goal
    program(bp, tokio).
	