/*trace*/
domains
  nev=symbol
  jegy=integer
  atlag=real
  nevlista=nev*
  atlaglista=atlag*
  
database
  szamolt(nev)
  beszurt(nev)
  
predicates
  info(nev,jegy)
  angol(nev,jegy)
  
  nem_ket_targybol(nev)
  afeladat 

  van_jobb_info(nev)
  van_rosszabb_angol(nev)
  bfeladat

  tanul(nev,jegy)
  otos_db(integer)
  cfeladat
  
  atlag(nev,atlag)
  nevek_atlagok(nevlista,atlaglista)
  kiir_nev_lista(nevlista)
  kiir_atlag_lista(atlaglista)
  dfeladat
 
 clauses

  info(feri,5).
  info(klara,5).
  info(peter,4).
  info(pista,2).  

  angol(feri,5).
  angol(peter,3).
  angol(pista,4).
  angol(vera,5).
  
  /************************* A feladat ************************************/

  nem_ket_targybol(Nev) if
   info(Nev,_) and not(angol(Nev,_)).

  nem_ket_targybol(Nev) if
   angol(Nev,_) and not(info(Nev,_)).

  afeladat if
   nem_ket_targybol(Nev) and
   write("Nem mindenki kapott jegyet mindkt trgybl. \n Pl.:",Nev,"\n") or
   write("Mindenki kapott jegyet mindkt trygbl.\n").
   
  /************************* B feladat ************************************/     
  van_jobb_info(Nev) if
   info(Nev,Jegy) and info(_,JobbJegy) and JobbJegy>Jegy.
   
  van_rosszabb_angol(Nev) if
   angol(Nev,Jegy) and angol(_,RosszabbJegy) and RosszabbJegy<Jegy.
  
  bfeladat if
   info(Nev,_) and angol(Nev,_) and
   not(van_jobb_info(Nev)) and not(van_rosszabb_angol(Nev)) and
   write(Nev," tanul a keresett tulajdonsg.\n")  or
   write("Nincs a  feladatban lert tulajdonsg tanul.\n").
   
  /************************* C feladat ************************************/      
  tanul(Nev,Jegy) if
   info(Nev,Jegy) or angol(Nev,Jegy).
   
  otos_db(Db) if 
   tanul(Nev,Jegy) and Jegy=5 and 
   not(szamolt(Nev)) and assert(szamolt(Nev)) and
   otos_db(DbMar) and Db=DbMar+1 or Db=0.
  
  cfeladat if
   retractall(szamolt(_)) and
   otos_db(Db) and
   write(Db, "db tanul kapott valamibl tst\n ").
  
    
 /************************* D feladat ************************************/            

  atlag(Nev,Atlag) if
   info(Nev,Jegy) and not(angol(Nev,_)) and Atlag=Jegy.
   
  atlag(Nev,Atlag) if
   angol(Nev,Jegy) and not(info(Nev,_)) and Atlag=Jegy.

  atlag(Nev,Atlag) if
   info(Nev,JegyI) and angol(Nev,JegyA) and Atlag=(JegyI+JegyA)/2.
   
  nevek_atlagok([Nev|MaradekNev],[Atlag|MaradekAtlag]) if
   atlag(Nev,Atlag) and not(beszurt(Nev)) and assert(beszurt(Nev)) and
   nevek_atlagok(MaradekNev,MaradekAtlag).   
  nevek_atlagok([],[]) if true.
  
  kiir_nev_lista([]) if true.
  kiir_nev_lista([E|Maradek]) if write(E,"\n") and kiir_nev_lista(Maradek).

  kiir_atlag_lista([]) if true.
  kiir_atlag_lista([E|Maradek]) if write(E,"\n") and kiir_atlag_lista(Maradek).
      
  dfeladat if 
      retractall(beszurt(_)) and
      nevek_atlagok(NevLista,AtlagLista) and 
      kiir_nev_lista(NevLista) and kiir_atlag_lista(AtlagLista).
      
 goal
   clearwindow and write("A feladat:\n") and afeladat and readln(_) and
   clearwindow and write("B feladat:\n") and bfeladat and readln(_) and
   clearwindow and write("C feladat:\n") and cfeladat and readln(_) and
   clearwindow and write("D feladat:\n") and dfeladat.  
